# coding: utf-8

"""
    lakeFS API

    lakeFS HTTP API

    The version of the OpenAPI document: 1.0.0
    Contact: services@treeverse.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, List, Optional
try:
    from pydantic.v1 import BaseModel, Field, StrictStr, conlist
except ImportError:
    from pydantic import BaseModel, Field, StrictStr, conlist

class ExternalPrincipal(BaseModel):
    """
    ExternalPrincipal
    """
    id: StrictStr = Field(..., description="A unique identifier for the external principal i.e aws:sts::123:assumed-role/role-name")
    user_id: StrictStr = Field(..., description="lakeFS user ID to associate with an external principal. ")
    settings: Optional[conlist(Dict[str, StrictStr])] = None
    __properties = ["id", "user_id", "settings"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ExternalPrincipal:
        """Create an instance of ExternalPrincipal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ExternalPrincipal:
        """Create an instance of ExternalPrincipal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ExternalPrincipal.parse_obj(obj)

        _obj = ExternalPrincipal.parse_obj({
            "id": obj.get("id"),
            "user_id": obj.get("user_id"),
            "settings": obj.get("settings")
        })
        return _obj


